<template>
  <div class="metadata">
    <div class="form-row form-group mandatory minWidthAP">
      <label
        for="ApplicationProfiles"
        class="col-sm-3 col-form-label text-right"
      >
        {{ $t("applicationProfilesLabel") }}
      </label>
      <div class="col">
        <b-form-select
          v-model="selectedApplicationProfile"
          :options="applicationProfileList"
          @change="notifyFormGenerator"
        >
          <template v-slot:first>
            <b-form-select-option :value="null" disabled>{{
              $t("MultiselectPlaceholderApplicationProfile")
            }}</b-form-select-option>
          </template>
        </b-form-select>
      </div>
      <div class="col-sm-2.75 paddingOr" v-html="$t('or')"></div>

      <div class="col-sm-2.75">
        <div v-if="emailAddressIsValid">
          <b-button
            class="btn btn-secondary float-right paddingCreateBtn"
            variant="outline-primary"
            v-b-tooltip.hover
            :title="$t('tooltipCreate')"
            name="createAP"
            @click="$bvModal.show('createAPModal')"
            >{{ $t("create") }}
          </b-button>
        </div>
        <div class="d-inline-flex ml-3" v-else>
          <span id="tooltipIdCreateDisabled">
            <b-tooltip target="tooltipIdCreateDisabled" triggers="hover">
              <i18n path="tooltipCreateDisabled">
                <template #linkToUserProfile>
                  <a :href="userLink">{{ $t("here") }}</a>
                </template>
              </i18n>
            </b-tooltip>
            <div class="d-inline-flex">
              <b-button
                class="btn btn-secondary float-right paddingCreateBtn"
                variant="outline-primary"
                disabled
                >{{ $t("create") }}</b-button
              >
            </div>
          </span>
        </div>
      </div>
    </div>
    <ModalCreateAP id="createAPModal" />
    <FormGenerator
      :key="resource.applicationProfile"
      :fixedValueMode="fixedValueMode"
      :fixedValues="resource.fixedValues"
      :applicationProfileId="resource.applicationProfile"
      :SHACLDefinition="JSON.stringify(applicationProfile)"
      mimeType="application/ld+json"
    />
    <b-button
      @click.prevent="back"
      class="btn btn-secondary"
      variant="outline-primary"
      >{{ $t("back") }}</b-button
    >
    <b-button
      @click.prevent="next"
      class="btn btn-secondary float-right"
      variant="outline-primary"
      :disabled="resource.applicationProfile === ''"
      >{{ $t("next") }}</b-button
    >
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { LinkUtil } from "@coscine/app-util";
import "@coscine/component-library/dist/index.css";

import { BFormSelect } from "bootstrap-vue";
import ModalCreateAP from "./ModalCreateAP/ModalCreateAP.vue";

import FormGenerator from "@coscine/form-generator";
import "@coscine/form-generator/dist/index.css";
Vue.use(FormGenerator);

// Not yet in use
export default Vue.extend({
  name: "Metadata",
  components: {
    BFormSelect,
    ModalCreateAP,
  },
  data() {
    return {
      userLink: LinkUtil.getRootLink("UserProfile"),
      applicationProfiles: [] as Array<unknown>,
      SHACLResponse: {},
      fixedValueMode: true,
      selectedApplicationProfile: {} as any,
      showModal: false,
    };
  },
  methods: {
    back() {
      this.$emit("back");
    },
    next() {
      this.$emit("next");
    },
    notifyFormGenerator() {
      this.$set(this.resource, "fixedValues", {});
      this.$set(
        this.resource,
        "applicationProfile",
        this.selectedApplicationProfile
      );
    },
    redirectionAims() {
      window.location.href =
        "https://coscine.rwth-aachen.de/coscine/apps/aimsfrontend/?token=" +
        window.coscine.authorization.bearer;
    },
  },
  props: {
    resource: Object,
    applicationProfileList: Array,
    applicationProfile: Array,
    emailAddressIsValid: Boolean,
  },
  mounted() {
    if (
      this.resource.applicationProfile !== null &&
      this.resource.applicationProfile !== ""
    ) {
      let text = this.resource.applicationProfile.replace(
        "https://purl.org/coscine/ap/",
        ""
      );
      if (text.charAt(text.length - 1) === "/") {
        text = text.substring(0, text.lastIndexOf("/"));
      }
      this.selectedApplicationProfile = {
        value: this.resource.applicationProfile,
        text: text.toUpperCase(),
      };
    } else {
      this.selectedApplicationProfile = null;
    }
  },
});
</script>

<style>
.metadata .lockButton {
  height: calc(1.4em + 0.75rem + 2px);
}
.metadata .material-design-icon__svg {
  margin-top: -0.1em;
}
.createAPModalLeftBtn {
  float: right;
  margin-right: 0.5rem !important;
}
.createAPModalRightBtn {
  float: right;
}
.minWidthAP {
  min-width: 100%;
}
.paddingOr {
  padding-left: 5px;
  padding-right: 5px;
  padding-top: 7px;
  padding-bottom: 7px;
  margin: 0px;
}
.paddingCreateBtn {
  padding-left: 3px;
  padding-right: 3px;
  padding-top: 6px;
  padding-bottom: 6px;
  margin-left: 5px;
  margin-right: 5px;
  margin-top: 0px;
  margin-bottom: 0px;
}
</style>
